function [R0 t0 error0 flag Mr] = ASPnP_Case2_V2(U,u)
%lift to 10-order)
%full-rank
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CORRECT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n = size(U,2);

sum_uv = sum(u,2);
invQTQ = inv([n   0   -sum_uv(1); 0 n -sum_uv(2); -sum_uv(1) -sum_uv(2) sum(sum(u.*u))]);

Ut = U';
ut = u';

temp1 = [Ut(:,1) 2*Ut(:,2) 2*Ut(:,3) -Ut(:,1) zeros(n,1) -Ut(:,1)];
temp2 = [Ut(:,3) zeros(n,1) -2*Ut(:,1) Ut(:,3) -2*Ut(:,2) -Ut(:,3)];
N1 = temp1 + temp2.*repmat(ut(:,1),1,6);

temp1 = [-Ut(:,2) 2*Ut(:,1) zeros(n,1) Ut(:,2) 2*Ut(:,3) -Ut(:,2)];
N2 = temp1 + temp2.*repmat(ut(:,2),1,6);

QTN = [-sum(N1,1); -sum(N2,1); u(1,:)*N1+u(2,:)*N2] ;
invQTQ_QTN = invQTQ*QTN;

M = -(QTN')*invQTQ_QTN + N1'*N1 + N2'*N2;


m11 = M(1,1); m12 = M(1,2); m13 = M(1,3); m14 = M(1,4); m15 = M(1,5); m16 = M(1,6); 
              m22 = M(2,2); m23 = M(2,3); m24 = M(2,4); m25 = M(2,5); m26 = M(2,6);
                            m33 = M(3,3); m34 = M(3,4); m35 = M(3,5); m36 = M(3,6);
                                          m44 = M(4,4); m45 = M(4,5); m46 = M(4,6); 
                                                        m55 = M(5,5); m56 = M(5,6); 
                                                                      m66 = M(6,6); 

%variable sequence
%[ c^3, c^2*d, c^2, c*d^2, c*d, c, d^3, d^2, d, 1]
a1 = [4*m44, 6*m45, 6*m24, 4*m46 + 2*m55, 4*m25 + 4*m34, 4*m14 + 2*m22, 2*m56, 2*m26 + 2*m35, 2*m15 + 2*m23, 2*m12];
b1 = [2*m45, 4*m46 + 2*m55, 2*m25 + 2*m34, 6*m56, 4*m26 + 4*m35, 2*m15 + 2*m23, 4*m66, 6*m36, 4*m16 + 2*m33, 2*m13];

%Groebner basis solver
c(1) = a1(1);
c(2) = a1(2);
c(3) = a1(4);
c(4) = a1(7);
c(5) = a1(3);
c(6) = a1(5);
c(7) = a1(8);
c(8) = a1(6);
c(9) = a1(9);
c(10) = a1(10);
c(11) = b1(1);
c(12) = b1(2);
c(13) = b1(4);
c(14) = b1(7);
c(15) = b1(3);
c(16) = b1(5);
c(17) = b1(8);
c(18) = b1(6);
c(19) = b1(9);
c(20) = b1(10);

M = zeros(12, 21);
ci = [9, 20, 31, 76, 87, 133];
M(ci) = c(1);

ci = [21, 32, 43, 88, 99, 145];
M(ci) = c(2);

ci = [33, 44, 55, 100, 111, 157];
M(ci) = c(3);

ci = [45, 56, 67, 112, 123, 169];
M(ci) = c(4);

ci = [81, 92, 103, 136, 147, 181];
M(ci) = c(5);

ci = [93, 104, 115, 148, 159, 193];
M(ci) = c(6);

ci = [105, 116, 127, 160, 171, 205];
M(ci) = c(7);

ci = [141, 152, 163, 184, 195, 217];
M(ci) = c(8);

ci = [153, 164, 175, 196, 207, 229];
M(ci) = c(9);

ci = [189, 200, 211, 220, 231, 241];
M(ci) = c(10);

ci = [12, 23, 34, 78, 89, 134];
M(ci) = c(11);

ci = [24, 35, 46, 90, 101, 146];
M(ci) = c(12);

ci = [36, 47, 58, 102, 113, 158];
M(ci) = c(13);

ci = [48, 59, 70, 114, 125, 170];
M(ci) = c(14);

ci = [84, 95, 106, 138, 149, 182];
M(ci) = c(15);

ci = [96, 107, 118, 150, 161, 194];
M(ci) = c(16);

ci = [108, 119, 130, 162, 173, 206];
M(ci) = c(17);

ci = [144, 155, 166, 186, 197, 218];
M(ci) = c(18);

ci = [156, 167, 178, 198, 209, 230];
M(ci) = c(19);

ci = [192, 203, 214, 222, 233, 242];
M(ci) = c(20);

index1 = [1:10,12,13]; index2 = [21 20 19 18 17 16 15 14 11];
Mr = M(:,index1)\M(:,index2);

A = zeros(9);
%amcols = [21 20 19 18 17 16 15 14 11];
A(1, 3) = 1;
A(2, 5) = 1;
A(3, 6) = 1;
A(4, 8) = 1;
A(5, :) = -Mr(12, :);
A(6, :) = -Mr(11, :);
A(7, :) = -Mr(10, :);
A(8, :) = -Mr(9, :);
A(9, :) = -Mr(5, :);

[V D] = eig(A);
sol =  V([3, 2],:)./(ones(2, 1)*V(1,:));

if (find(isnan(sol(:))) > 0)
    y = [];
    z = [];
else

    I = find(not(imag( sol(1,:) )));
    y = sol(1,I);
    z = sol(2,I);
end

%
R0 = []; t0 = []; error0 = inf;
for i = 1:length(y)
    c = y(i); d = z(i);
    
    R = 1/(1+c^2+d^2)*[1-c^2-d^2     2*c      2*d
                       2*c         -1+c^2-d^2 2*c*d
                       2*d          2*c*d     -1-c^2+d^2];
    vec1 = [1 c d c^2 c*d d^2];
    t = invQTQ_QTN*vec1'/(1+c^2+d^2);
    proj = R*U+t*ones(1,n);

%     if min(proj(3,:)) < 0
%         continue;
%     end
% 
%     proj = proj./repmat(proj(3,:),3,1);    
%     err = norm(proj(1:2,:)-u,'fro')/n;
% 
%     %choose the solution with smallest reprojection error
%     if err < error0
%         R0 = R; t0 = t; error0 = err;
%     end
    R0 = cat(3,R0,R);
    t0 = [t0 t];
end


end

 

 